apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  name: python-twine
spec:
  description: >-
    Uploads pyton packages to a PyPi service.
  workspaces:
  - name: dist
    description: A workspace where distribution artifacts will be written
  params:
  - name: repository
    description: Repository to upload to
    type: string
    default: "https://pypi.jobtechdev.se/repository/pypi-jobtech/"
  - name: twine-secret
    description: Ref to secret containing environment variables TWINE_USERNAME and TWINE_PASSWORD
  - name: image
    default: "docker.io/library/python:3-slim-bullseye"
  steps:
  - name: upload
    image: "$(params.image)"
    workingDir: $(workspaces.dist.path)
    env:
    - name: HOME
      value: /tekton/home
    envFrom:
    - secretRef:
        name: $(params.twine-secret)
    script: |
      #!/bin/sh -x

      python -m pip install --upgrade twine
      python -m twine upload --repository-url $(params.repository) *.whl *.tar.gz
